Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Time tracking Estimated time: 0.00 hour
Target version: 4.2.11

Resolution: Fixed Affected version: 4.1.0
Description

Given

® an existing time entry
e Setting.timelog_accept_future_dates? is disabled

then editing the time entry to remove the spent_on field (i.e. setting it to nil or an empty string) results in the following exception:

NoMethodError: undefined method ">' for nil:NilClass
app/models/time_entry.rb:187:in “validate_time_entry'

Here, it is assumed that the spent_on value is always present as validated by the validates_presence_of :spent_on. During
validations however, this may not always be the case as Rails always runs all validations, regardless of any prior failing validations.
The issue was originally introduced in #3322, first released with 4.1.0.

The attached patch fixes this error by only checking the spent_on value in validate_time_entry if it was provided. If it is missing or is
wrongly formatted, the other validations will catch this and still reject to save the model.

Associated revisions

Revision 22311 - 2023-09-20 06:43 - Go MAEDA

Avoid exception during validation if the spent_on date of a time entry was removed (#39079).

Patch by Holger Just.

Revision 22312 - 2023-09-20 06:47 - Go MAEDA
Merged r22311 from trunk to 5.0-stable (#39079).

Revision 22313 - 2023-09-20 06:48 - Go MAEDA
Merged r22311 from trunk to 4.2-stable (#39079).

History

#1 - 2023-09-19 18:10 - Holger Just

- Description updated

#2 - 2023-09-20 06:31 - Go MAEDA
- Status changed from New to Confirmed

- Target version set to 4.2.11

#3 - 2023-09-20 06:49 - Go MAEDA
- Status changed from Confirmed to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix. Thank you.
